[leetcode] 213. House Robber II

Description

You are a professional robber planning to rob houses along a street. Each house has a certain amount of money stashed. All houses at this place are arranged in a circle. That means the first house is the neighbor of the last one. Meanwhile, adjacent houses have security system connected and it will automatically contact the police if two adjacent houses were broken into on the same night.

Given a list of non-negative integers representing the amount of money of each house, determine the maximum amount of money you can rob tonight without alerting the police.

Example 1:

Input: [2,3,2]
Output: 3
Explanation: You cannot rob house 1 (money = 2) and then rob house 3 (money = 2),
             because they are adjacent houses.

Example 2:

Input: [1,2,3,1]
Output: 4
Explanation: Rob house 1 (money = 1) and then rob house 3 (money = 3).
             Total amount you can rob = 1 + 3 = 4.

分析

题目的意思是:给你一个数组,成环(最后一个数跟第一个数相邻),然后相邻的房间不能抢,只能隔开抢劫,求你能够抢到的最大价值。

  • 现在房子排成了一个圆圈,则如果抢了第一家,就不能抢最后一家,因为首尾相连了,所以第一家和最后一家只能抢其中的一家,或者都不抢。
  • 那我们这里变通一下,如果我们把第一家和最后一家分别去掉,各算一遍能抢的最大值,然后比较两个值取其中较大的一个即为所求。
    dp[i]表示前i个房子,强盗能够抢到的最大值。
    很容易推出:
    dp[i]=max(dp[i-2]+nums[i],dp[i-1]);
    对于每一个位置,有抢与不抢,抢就是dp[i-2]+nums[i],不抢就是:dp[i-1]取最大值作为当前抢到的最大值。

C++实现

class Solution {
public:
    int rob(vector<int>& nums) {
        if(nums.size()==0){
            return 0;
        }
        if(nums.size()==1){
            return nums[0];
        }
        return max(rob(nums,0,nums.size()-1),rob(nums,1,nums.size()));
    }
    int rob(vector<int> nums,int left,int right){
        if(right-left<=1){
            return nums[left];
        }
        vector<int> dp(right,0);
        dp[left]=nums[left];
        dp[left+1]=max(nums[left],nums[left+1]);
        for(int i=left+2;i<right;i++){
            dp[i]=max(dp[i-2]+nums[i],dp[i-1]);
        }
        return dp[right-1];
    }
};

Python实现

class Solution:
    def solve(self, nums):
        n = len(nums)
        dp = [0]*n
        dp[0]=nums[0]
        dp[1]=max(nums[0],nums[1])
        for i in range(2,n):
            dp[i]=max(dp[i-2]+nums[i],dp[i-1])
        return dp[n-1]

    def rob(self, nums: List[int]) -> int:
        # dp[i]=max(dp[i-2]+nums[i],dp[i-1])
        if len(nums)<=2:
            return max(nums)
        return max(self.solve(nums[0:len(nums)-1]),self.solve(nums[1:]))

参考文献

[LeetCode] House Robber II 打家劫舍之二

评论 1
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包

打赏作者

农民小飞侠

你的鼓励将是我创作的最大动力

¥1 ¥2 ¥4 ¥6 ¥10 ¥20
扫码支付:¥1
获取中
扫码支付

您的余额不足,请更换扫码支付或充值

打赏作者

实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值